"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const config_1 = require("../config");
const webpack = require("webpack");
const utils_1 = require("../utils");
const startWebpack = (env, opts) => {
    const userConfig = utils_1.getUserConfig();
    const config = config_1.default(env, userConfig, opts.d);
    config.mode = env;
    webpack(config, error => {
        if (error) {
            console.error(error);
            return;
        }
    });
};
module.exports = opts => {
    process.env.NODE_ENV = "production";
    if (opts.dev) {
        process.env.NODE_ENV = "development";
    }
    if (opts.analyze) {
        process.env.BUNDLE_ANALYZE = "true";
    }
    if (opts.smp) {
        process.env.SMP = "true";
    }
    startWebpack(process.env.NODE_ENV, opts);
};
//# sourceMappingURL=build.js.map