"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const path_1 = require("path");
exports.rootPath = path_1.resolve(process.cwd());
exports.requireFx = typeof __webpack_require__ === "function" ? __non_webpack_require__ : require;
exports.getPaths = (userPaths = {}) => (Object.assign({ src: path_1.join(exports.rootPath, "./src"), entry: {
        main: path_1.join(exports.rootPath, "./src/index")
    }, outputFolder: path_1.join(exports.rootPath, "./dist") }, userPaths));
exports.resolveHtmlTemplate = () => {
    const srcHtmlPath = path_1.resolve(exports.rootPath, "./src/index.html");
    const assetsHtmlPath = path_1.resolve(exports.rootPath, "./assets/index.html");
    const rootHtmlPath = path_1.resolve(exports.rootPath, "./index.html");
    if (fs_1.existsSync(srcHtmlPath)) {
        return srcHtmlPath;
    }
    if (fs_1.existsSync(assetsHtmlPath)) {
        return assetsHtmlPath;
    }
    if (fs_1.existsSync(rootHtmlPath)) {
        return rootHtmlPath;
    }
};
exports.makeDevEntry = (entry, port) => {
    return [
        require.resolve("webpack-dev-server/client") + `?http://localhost:${port}`,
        require.resolve("webpack/hot/dev-server"),
        entry
    ];
};
exports.makeDevEntries = (entries, port) => {
    Object.keys(entries).forEach(entryKey => {
        const entry = entries[entryKey];
        entries[entryKey] = exports.makeDevEntry(entry, port);
    });
    return entries;
};
exports.isBackEndConfig = mode => mode === "node";
exports.resolveLocal = (...args) => {
    return path_1.join(__dirname, "../../", ...args);
};
exports.resolveContext = (context, path) => {
    return path_1.resolve(context, path);
};
exports.getFile = relativePath => {
    const filepath = path_1.join(exports.rootPath, relativePath);
    if (fs_1.existsSync(filepath)) {
        return exports.requireFx(filepath);
    }
};
exports.getUserConfig = () => {
    const userConfigPath = path_1.join(exports.rootPath, "./typepack.ts");
    if (fs_1.existsSync(userConfigPath)) {
        return exports.requireFx(userConfigPath);
    }
    return {};
};
//# sourceMappingURL=utils.js.map